<div class="contenedor">
  <app-side-bar></app-side-bar>
  <div class="position-relative">
    <div class="position-relative d-flex justify-content-between align-items-center p-3">
      <!-- Titulo de la página, buscador y calendario -->
      <div class="d-flex align-items-center">
        <h1 class="me-4">Proyectos</h1>
        <div>
          <button (click)="abrirModalVacio()" class="btn btn-primary add">+</button>
        </div>
      </div>
      <div class="d-flex">
        <!-- Calendario -->
        <div class="d-flex align-items-center position-relative">
          <div [ngClass]="{'pressed-button': startDate.value !== ''}" class="pressed-button me-4">
            <img class="cursor-pointer" (click)="openCalendar()" src="assets/img/calendario.svg">
          </div>
          <form #calendar class="col visibility-hidden sombra calendario">
            <img class="cross position-absolute cursor-pointer" (click)="closeCalendar()" src="assets/img/xmark.svg">
            <div class="row d-flex mb-3">
              <div class="col-sm-6 max-content mb-2">
                <p class="max-content">Inicio</p>
                <input #startDate type="date">
              </div>
              <div class="col-sm-6 max-content mb-2">
                <p class="max-content">Fin</p>
                <input #endDate type="date">
              </div>
            </div>
            <div class="justify-content-center d-flex">
              <button (click)="removeDate()" class="btn btn-outline-secondary me-3">Borrar</button>
              <button (click)="searchDate()" class="btn btn-primary text-white">Buscar</button>
            </div>
          </form>
        </div>
        <!-- Buscador -->
        <div class="position-relative align-items-center d-flex">
          <input #searchInput (input)="search($event)" class="align-self-center buscador entrada sombra" type="text" placeholder="Buscar" name="buscar">
          <ul *ngIf="searchResults.length > 0" class="list-group position-absolute busqueda">
            <li *ngFor="let result of searchResults" class="list-group-item" (click)="selectResult(result)">
              <span [innerHTML]="result"></span>
            </li>
          </ul>
        </div>
      </div>
    </div>
    <!-- Tabla -->
    <div class="alturaTabla">
      <table class="table table-hover">
        <thead>
          <tr>
            <!-- <th>
              <div class="d-flex align-items-center">
                <div class="custom-control custom-checkbox ml">
                  <input type="checkbox" class="custom-control-input" id="customCheck2">
                </div>
                <div class="d-flex flex-direction mFlechas visibility-hidden">
                  <img class="flechas cursor-pointer" src="assets/img/flecha_arriba_blanca.svg">
                  <img class="flechas cursor-pointer" src="assets/img/flecha_abajo_blanca.svg">
                </div>
              </div>
            </th> -->
            <th>
              <div class="d-flex align-items-center">
                <div>
                  Código
                </div>
                <div class="d-flex flex-direction mFlechas">
                  <img (click)="ordenar('asc', 'codigo')" class="flechas cursor-pointer" src="assets/img/flecha_arriba_blanca.svg">
                  <img (click)="ordenar('desc', 'codigo')" class="flechas cursor-pointer" src="assets/img/flecha_abajo_blanca.svg">
                </div>
              </div>
            </th>
            <th>
              <div class="d-flex align-items-center">
                <div>
                  Título
                </div>
                <div class="d-flex flex-direction mFlechas">
                  <img (click)="ordenar('asc', 'nombre')" class="flechas cursor-pointer" src="assets/img/flecha_arriba_blanca.svg">
                  <img (click)="ordenar('desc', 'nombre')" class="flechas cursor-pointer" src="assets/img/flecha_abajo_blanca.svg">
                </div>
              </div>
            </th>
            <th>
              <div class="d-flex align-items-center">
                <div>
                  Usuario asignado
                </div>
                <div class="d-flex flex-direction mFlechas">
                  <img (click)="ordenar('asc', 'autor')" class="flechas cursor-pointer" src="assets/img/flecha_arriba_blanca.svg">
                  <img (click)="ordenar('desc', 'autor')" class="flechas cursor-pointer" src="assets/img/flecha_abajo_blanca.svg">
                </div>
              </div>
            </th>
            <th>
              <div class="d-flex align-items-center">
                <div>
                  Fecha Creación
                </div>
                <div class="d-flex flex-direction mFlechas">
                  <img (click)="ordenar('asc', 'fechaCreacion')" class="flechas cursor-pointer" src="assets/img/flecha_arriba_blanca.svg">
                  <img (click)="ordenar('desc', 'fechaCreacion')" class="flechas cursor-pointer" src="assets/img/flecha_abajo_blanca.svg">
                </div>
              </div>
            </th>
            <th>
              <div class="d-flex align-items-center">
                <div>
                  Documentación
                </div>
                <div class="d-flex flex-direction mFlechas visibility-hidden">
                  <img class="flechas cursor-pointer" src="assets/img/flecha_arriba_blanca.svg">
                  <img class="flechas cursor-pointer" src="assets/img/flecha_abajo_blanca.svg">
                </div>
              </div>
            </th>
            <th>
              <div class="d-flex align-items-center">
                <div>
                  Incidencias
                </div>
                <div class="d-flex flex-direction mFlechas visibility-hidden">
                  <img class="flechas cursor-pointer" src="assets/img/flecha_arriba_blanca.svg">
                  <img class="flechas cursor-pointer" src="assets/img/flecha_abajo_blanca.svg">
                </div>
              </div>
            </th>
            <th>
              <div class="d-flex align-items-center">
                <div>
                  Inspecciones
                </div>
                <div class="d-flex flex-direction mFlechas visibility-hidden">
                  <img class="flechas cursor-pointer" src="assets/img/flecha_arriba_blanca.svg">
                  <img class="flechas cursor-pointer" src="assets/img/flecha_abajo_blanca.svg">
                </div>
              </div>
            </th>
            <th>
              <div class="d-flex align-items-center">
                <div>
                  Informes
                </div>
                <div class="d-flex flex-direction mFlechas visibility-hidden">
                  <img class="flechas cursor-pointer" src="assets/img/flecha_arriba_blanca.svg">
                  <img class="flechas cursor-pointer" src="assets/img/flecha_abajo_blanca.svg">
                </div>
              </div>
            </th>
          </tr>
        </thead>
        <tbody *ngIf="loadCompleted">
          <tr (click)="verProyecto(proyecto)" class="cursor-pointer" *ngFor="let proyecto of proyectos; let i = index">
            <!-- <td>
              <div class="custom-control custom-checkbox ml">
                  <input type="checkbox" class="custom-control-input" id="customCheck2">
              </div>
            </td> -->
            <td class="align-items-center">{{proyecto.codigo}}</td>
            <td class="align-items-center">{{proyecto.nombre}}</td>
            <td class="align-items-center">{{proyecto.autorNombre}}</td>
            <td class="align-items-center">{{proyecto.fechaCreacion | date:'dd/MM/yy, h:mm:ss a'}}</td>
            <td class="align-items-center">
              <div *ngFor="let documento of proyecto.documentos">
                <a class ="link" (click)="descargar(documento)">{{documento}}</a>
              </div>
              <!-- <a class ="link" (click)="descargar('https://blog.novatr.com/hubfs/6%20Best%20BIM%20Courses%20With%20Placements.jpg','image')">prueba.JPG</a> -->
            </td>
            <td class="align-items-center">{{proyecto.numInc}}</td>
            <td class="align-items-center">{{proyecto.numIns}}</td>
            <td class="align-items-center">
              <img class="icon" (click)="openQR(proyecto.codigo); $event.stopPropagation()" src="assets/img/qr.svg">
              <button (click)="verInforme(proyecto.uid!)" type="button" class="btn btn-primary boton">Ver</button>
            </td>
          </tr>
        </tbody>
      </table>
    </div>
     <!-- Loading -->
     <div class="d-flex justify-content-center loading" *ngIf="!loadCompleted">
      cargando
    </div>
    <!-- Paginacion -->
    <div class="mt-2 position-absolute bottom-0 w-100">
      <app-pagination (changePage)="changePage($event)" [dataLoaded]="loadCompleted" [recordsTotal]="recordsTotal" [recordCurrent]="recordCurrent + 1" [recordsPerPage]="recordsPerPage"></app-pagination>
    </div>
    <section id="copia" class="visibility-hidden side-ventana" #copia>
      <div *ngIf="proyectoCopia">
        <div class="d-flex row justify-content-between">
          <h5 class="col mb-4">{{proyectoCopia.nombre}}</h5>
          <div class="col-2" style="display: contents;">
            <img (click)="editarProyecto()" class="cursor-pointer" src="assets/img/edit.svg">
            <img (click)="cerrarInfo()" class="cursor-pointer" src="assets/img/xmark.svg">
          </div>
        </div>
        <div class="mb-2">
          <h6>Usuario asignado</h6>
          <p>{{proyectoCopia.autorNombre}}</p>
        </div>
        <hr>
        <div class="mb-2">
          <div class="d-flex justify-content-between align-items-center">
            <h6>Documentación</h6>
            <h3 #botonDocu (click)="verInformacion(documentacionLista, botonDocu)">+</h3>
          </div>
          <div #documentacionLista class="display-none">
            <div *ngFor="let documento of proyectoCopia.documentos">
              <div class="d-flex">
                <a class ="link" (click)="descargar(documento)">{{documento}}</a>
              </div>
            </div>
          </div>
        </div>
        <hr>
        <div>
          <div class="d-flex justify-content-between align-items-center">
            <h6>Incidencias</h6>
            <h3 #botonInci (click)="verInformacion(incidenciasLista, botonInci)">+</h3>
          </div>
          <div #incidenciasLista class="display-none">
            <!-- <button class="btn btn-primary mb-2" (click)="crearIncidencia()">Nueva Incidencia</button> -->
            <table *ngIf="incidenciasProyecto.length > 0" table class="table table-bordered">
              <thead>
                <tr>
                  <th scope="col">Incidencias</th>
                  <th scope="col">Situación de la incidencia</th>
                </tr>
              </thead>
              <tbody>
                <tr *ngFor="let incidencia of incidenciasProyecto">
                  <td class="link">{{incidencia.codigo}}</td>
                  <td>{{incidencia.estado}}</td>
                </tr>
              </tbody>
            </table>
          </div>
        </div>
      </div>
    </section>

    <!-- Formulario -->
    <section #modal class="d-flex justify-content-center align-items-center ventanaModal visibility-hidden">
      <div class="modalContent">
        <h4 *ngIf="crear" class="text-white text-center">Nuevo Proyecto</h4>
        <h4 *ngIf="!crear" class="text-white text-center">Editar Proyecto</h4>
        <form class="p4" [formGroup]="proyectoForm">
          <div class="form-group d-flex justify-content-between mb-3">
            <div  class="tamInput">
              <label for="nombre" class="form-label">Título</label>
              <input type="text" formControlName="nombre"  class="form-control" required autofocus>
            </div>
          </div>
          <div class="mt-2 d-flex" #incidencias></div>
          <div class="form-group d-flex justify-content-between mb-3">
            <div>
              <label for="nombre" class="form-label">Documentación</label>
              <div #documentosForm *ngIf="!crear && proyectoCopia && proyectoCopia.documentos.length > 0" class="mb-4">
                <div *ngFor="let documento of proyectoCopia.documentos">
                  <div class="d-flex doc justify-content-between mb-2">
                    <a>{{documento}}</a>
                    <p class="ms-2 cursor-pointer" (click)="deleteFile(documento)">x</p>
                  </div>
                </div>
              </div>
              <p id="subirArchivos">Seleccionar archivos</p>
              <input id="upload" aria-label="Seleccionar archivos" (change)="addFile($event)" type="file" class="form-control" required multiple>
            </div>
            <div class="mt-4" #documentacion></div>
          </div>
          <!-- <p class="text-danger" *ngIf="formInvalid">{{text('empresaModal.aviso')}}</p>
          <p class="text-danger" *ngIf="nombreRepetido">{{text('empresaModal.avisoNombre')}}</p> -->
          <div class="d-flex justify-content-center">
            <button (click)="esconderModal()" type="button" class="btn text-white bgGray me-4">Cancelar</button>
            <button *ngIf="!crear" type="submit" (click)="actualizarProyecto()" class="btn text-white bgBlue">Guardar</button>
            <button *ngIf="crear" type="button" (click)="crearProyecto()" class="btn text-white bgBlue">Crear</button>
          </div>
        </form>
      </div>
    </section>

    <!-- Modal incidencia -->
    <app-incidence-form (hideModal)="getHideModal($event)" *ngIf="mostrarModal" [proyecto]="proyectoId">
    </app-incidence-form>

    <!-- Generador QR -->
    <section id="qrCode" *ngIf="showQR" class="d-flex justify-content-center align-items-center">
      <div class="position-relative sombra d-flex justify-content-center align-items-center">
        <img (click)="closeQR()" id="cross" class="cursor-pointer position-absolute" src="assets/img/xmark.svg">
        <qrcode [qrdata]="qrContenido" [width]="250"></qrcode>
      </div>
    </section>
  </div>
</div>
